From 59e3e568d3627eda67c868f9f605954cbe6fd66b Mon Sep 17 00:00:00 2001
From: Jon Jensen <jon@endpoint.com>
Date: Wed, 11 Jan 2012 22:01:38 -0700
Subject: [PATCH] Remove documentation for defzombie setting which doesn't
 exist

---
 src/doc/screen.1       | 11 +----------
 src/doc/screen.texinfo |  6 +-----
 src/etc/completer.zsh  |  4 ++--
 3 files changed, 4 insertions(+), 17 deletions(-)

diff --git a/src/doc/screen.1 b/src/doc/screen.1
index c175891..83f7bf9 100644
--- a/src/doc/screen.1
+++ b/src/doc/screen.1
@@ -1669,12 +1669,6 @@ Same as the \fBwritelock\fP command except that the default setting for new
 windows is changed. Initially writelocks will off.
 .sp
 .ne 3
-.BR "defzombie " [\fIkeys\fP]
-.PP
-Synonym to the \fBzombie\fP command. Both currently change the default.
-See there.
-.sp
-.ne 3
 .B detach
 .RB [ -h ]
 .PP
@@ -3510,8 +3504,6 @@ Note also that this is an experimental feature.
 .sp
 .ne 3
 .BR "zombie " [\fIkeys\fP [ onerror ] ]
-.br
-.BR "defzombie " [\fIkeys\fP]
 .PP
 Per default
 .I screen 
@@ -3528,8 +3520,7 @@ without parameters will clear the zombie setting, thus making windows disappear
 when their process exits.
 
 As the zombie-setting is manipulated globally for all windows, this command 
-should only be called \fBdefzombie\fP. Until we need this as a per window 
-setting, the commands \fBzombie\fP and \fBdefzombie\fP are synonymous.
+should probably be called \fBdefzombie\fP, but it isn't.
 
 Optionally you can put the word \*Qonerror\*U after the keys. This will cause screen
 to monitor exit status of the process running in the window. If it exits normally ('0'), 
diff --git a/src/doc/screen.texinfo b/src/doc/screen.texinfo
index 08ca259..40865e9 100644
--- a/src/doc/screen.texinfo
+++ b/src/doc/screen.texinfo
@@ -974,8 +974,6 @@ Select default character encoding.  @xref{Character Processing}.
 Set default line-wrapping behavior.  @xref{Wrap}.
 @item defwritelock @var{on|off|auto}
 Set default writelock behavior.  @xref{Multiuser Session}.
-@item defzombie [@var{keys}]
-Keep dead windows.  @xref{Zombie}.
 @item detach [-h]
 Disconnect @code{screen} from the terminal.  @xref{Detach}.
 @item digraph [@var{preset} [@var{unicode-value}]]
@@ -5217,7 +5215,6 @@ Display the version and modification date in the message line.
 @node Zombie, Printcmd, Version, Miscellaneous
 @section Zombie
 @deffn Command zombie [@var{keys} [onerror] ]
-@deffnx Command defzombie [@var{keys}]
 (none)@*
 Per default windows are removed from the window list as soon as the
 windows process (e.g. shell) exits. When a string of two keys is
@@ -5230,8 +5227,7 @@ parameters will clear the zombie setting, thus making windows disappear when
 the process terminates.
 
 As the zombie setting is affected globally for all windows, this command 
-should only be called @code{defzombie}. Until we need this as a per window 
-setting, the commands @code{zombie} and @code{defzombie} are synonymous.
+should probably be called @code{defzombie}, but it isn't.
 
 Optionally you can put the word @code{onerror} after the keys. This will
 cause screen to monitor exit status of the process running in the window.
diff --git a/src/etc/completer.zsh b/src/etc/completer.zsh
index bbbd01c..b5acaa3 100644
--- a/src/etc/completer.zsh
+++ b/src/etc/completer.zsh
@@ -37,9 +37,9 @@
 		'-v[Print "Screen version 3.09.11beta (FAU) 11-Oct-01".]' \
 		'-wipe[Do nothing, just clean up SockDir.]' \
 		'-x[Attach to a not detached screen. (Multi display mode).]' \
-		'-X[Execute <cmd> as a screen command in the specified session.]:Handling Tag screencmd:( acladd  addacl  aclchg  acldel  aclgrp  aclumask  activity  allpartial  at  attrcolor  autodetach  autonuke  bce  bell_msg  bind  bindkey  break  breaktype  bufferfile  c1  caption  charset  chdir  clear  colon  command  compacthist  console  copy  copy_reg  crlf  debug  defc1  defautonuke  defbce  defbreaktype  defcharset  defescape  defflow  defgr  defhstatus  defkanji  deflogin  defmode  defmonitor  defobuflimit  defscrollback  defshell  defsilence  defslowpaste  defutf8  defwrap  defwritelock  defzombie  detach  dinfo  displays  digraph  dumptermcap  echo  escape  exec  fit  flow  focus  gr  hardcopy  hardcopy_append  hardcopydir  hardstatus  height  help  history  hstatus  info  ins_reg  kill  lastmsg  license  lockscreen  log  logfile  login  logtstamp  mapdefault  mapnotnext  maptimeout  markkeys  meta  monitor  msgminwait  msgwait  multiuser  nethack  next  nonblock  number  obu!
+		'-X[Execute <cmd> as a screen command in the specified session.]:Handling Tag screencmd:( acladd  addacl  aclchg  acldel  aclgrp  aclumask  activity  allpartial  at  attrcolor  autodetach  autonuke  bce  bell_msg  bind  bindkey  break  breaktype  bufferfile  c1  caption  charset  chdir  clear  colon  command  compacthist  console  copy  copy_reg  crlf  debug  defc1  defautonuke  defbce  defbreaktype  defcharset  defescape  defflow  defgr  defhstatus  defkanji  deflogin  defmode  defmonitor  defobuflimit  defscrollback  defshell  defsilence  defslowpaste  defutf8  defwrap  defwritelock  detach  dinfo  displays  digraph  dumptermcap  echo  escape  exec  fit  flow  focus  gr  hardcopy  hardcopy_append  hardcopydir  hardstatus  height  help  history  hstatus  info  ins_reg  kill  lastmsg  license  lockscreen  log  logfile  login  logtstamp  mapdefault  mapnotnext  maptimeout  markkeys  meta  monitor  msgminwait  msgwait  multiuser  nethack  next  nonblock  number  obu!
 !
-flimit  only  other  partial  password  paste  pastefont  pow_break  pow_detach  pow_detach_msg  prev  printcmd  process  quit  readbuf  readreg  redisplay  register  remove  removebuf  reset  resize  screen  scrollback  select  sessionname  setenv  shell  shelltitle  silence  silencewait  sleep  slowpaste  sorendition  split  startup_message  stuff  su  term  termcap  terminfo  termcapinfo  time  title  unsetenv  utf8  vbell  vbell_msg  vbellwait  verbose  version  wall  width  windows  wrap  writebuf  writelock  xoff  xon  zombie  defzombie)'
+flimit  only  other  partial  password  paste  pastefont  pow_break  pow_detach  pow_detach_msg  prev  printcmd  process  quit  readbuf  readreg  redisplay  register  remove  removebuf  reset  resize  screen  scrollback  select  sessionname  setenv  shell  shelltitle  silence  silencewait  sleep  slowpaste  sorendition  split  startup_message  stuff  su  term  termcap  terminfo  termcapinfo  time  title  unsetenv  utf8  vbell  vbell_msg  vbellwait  verbose  version  wall  width  windows  wrap  writebuf  writelock  xoff  xon  zombie)'
 case $state in
   "sessionname")
   # Complete folder names.