--- ../../../INSTALLED/freefont/sfd/FreeSans.sfd	2011-12-26 10:49:07.083011001 +0100
+++ FreeSans.sfd	2011-12-26 11:59:06.293011005 +0100
@@ -19,7 +19,7 @@
 OS2_WeightWidthSlopeOnly: 0
 OS2_UseTypoMetrics: 1
 CreationTime: 1203284335
-ModificationTime: 1324299160
+ModificationTime: 1324897143
 PfmFamily: 33
 TTFWeight: 400
 TTFWidth: 5
@@ -267,7 +267,7 @@
 LangName: 1026 "" "" "+BD0EPgRABDwEMAQ7BDUEPQAA" 
 LangName: 1069 "" "" "Arrunta" 
 LangName: 1033 "" "" "" "" "" "" "" "" "GNU" "" "" "https://savannah.gnu.org/projects/freefont/" "" "This computer font is part of GNU FreeFont.  It is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.+AAoACgAA-This font is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.+AAoACgAA-You should have received a copy of the GNU General Public License along with this font.  If not, see +AAoA    http://www.gnu.org/licenses/+AAoACgAA-As a special exception, if you create a document which uses this font, and embed this font or unaltered portions of this font into the document, this font does not by itself cause the resulting document to be covered by the GNU General Public License. This exception does not however invalidate any other reasons why the document might be covered by the GNU General Public License. If you modify this font, you may extend this exception to your version of the font, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version." "http://www.gnu.org/copyleft/gpl.html" 
-GaspTable: 3 9 14 22 13 65535 15 1
+GaspTable: 3 9 14 22 13 65535 15
 Encoding: Custom
 UnicodeInterp: none
 NameList: Adobe Glyph List
@@ -297,7 +297,7 @@
  1999 284 l 0
 EndSplineSet
 AnchorClass2: "syr_below"  "'mark' Mark Positioning in Syriac subtable" "syr_above"  "'mark' Mark Positioning in Syriac subtable" "above_mid_heb"  "'mark' Mark Positioning in Hebrew subtable" "vowel_below_yiddish"  "'mark' Mark Positioning in Yiddish" "vowel_above_heb"  "'mark' Mark Positioning in Hebrew subtable" "vowel_left_heb"  "'mark' Mark Positioning in Hebrew subtable" "vowel_below_heb"  "'mark' Mark Positioning in Hebrew 2 subtable" "abovemk_cyr"  "'mkmk' Mark to Mark in Cyrillic subtable" "topright"  "'mark' Mark Positioning in Latin 2 subtable" "abovecyr"  "'mark' Mark Positioning in Cyrillic subtable" "middle"  "'mark' Mark Positioning subtable" "ogonek"  "'mark' Mark Positioning in Latin subtable 2" "dvng-0"  "'abvm' Above Base Mark in Devanagari subtable" "gujr-0"  "'abvm' Above Base Mark in Gujarati subtable" "dvng-1"  "'blwm' Below Base Mark in Devanagari subtable" "gujr-1"  "'blwm' Below Base Mark in Gujarati subtable" "above"  "'mark' Mark Positioning in Latin 1 subtable" "below"  "'mark' Mark Positioning in Latin subtable" 
-BeginChars: 69525 6517
+BeginChars: 69525 6519
 
 StartChar: space
 Encoding: 32 32 0
@@ -205316,41 +205316,124 @@
 
 StartChar: uni2639
 Encoding: 9785 9785 6516
-Width: 729
+Width: 770
 VWidth: 0
 Flags: HW
 LayerCount: 2
 Fore
 SplineSet
-653 330 m 0
- 653 494.452 517.73 620 364 620 c 0
- 199.57 620 74 484.807 74 330 c 0
- 74 174.632 200.239 40 364 40 c 0
- 518.386 40 653 164.914 653 330 c 0
-364 660 m 0
- 539.441 660 694 516.785 694 330 c 0
- 694 142.583 539.603 0 364 0 c 0
- 186.03 0 34 143.222 34 330 c 0
- 34 505.321 176.358 660 364 660 c 0
-464 168 m 1
- 437 193 401 207 364 207 c 0
- 326 207 291 193 263 168 c 1
- 245 185 l 1
- 264 234 311 267 364 267 c 0
- 416 267 463 234 482 185 c 1
- 464 168 l 1
-263 389 m 0
- 240 389 221 408 221 430 c 0
- 221 453 240 472 263 472 c 0
- 285 472 305 452 305 430 c 0
- 305 408 284 389 263 389 c 0
-464 389 m 0
- 441 389 423 408 423 430 c 0
- 423 453 441 472 464 472 c 0
- 488 472 506 453 506 430 c 0
- 506 407 487 389 464 389 c 0
+691.553710938 350 m 0
+ 691.553710938 524.418945312 548.086914062 657.576171875 385.0390625 657.576171875 c 0
+ 210.642578125 657.576171875 77.462890625 514.188476562 77.462890625 350 c 0
+ 77.462890625 185.215820312 211.353515625 42.423828125 385.0390625 42.423828125 c 0
+ 548.78125 42.423828125 691.553710938 174.909179688 691.553710938 350 c 0
+385.0390625 700 m 0
+ 571.11328125 700 735.0390625 548.10546875 735.0390625 350 c 0
+ 735.0390625 151.224609375 571.284179688 0 385.0390625 0 c 0
+ 196.283203125 0 35.0390625 151.901367188 35.0390625 350 c 0
+ 35.0390625 535.947265625 186.025390625 700 385.0390625 700 c 0
+491.099609375 178.181640625 m 1
+ 462.462890625 204.697265625 424.28125 219.545898438 385.0390625 219.545898438 c 0
+ 344.736328125 219.545898438 307.615234375 204.697265625 277.91796875 178.181640625 c 1
+ 258.827148438 196.211914062 l 1
+ 278.978515625 248.181640625 328.827148438 283.181640625 385.0390625 283.181640625 c 0
+ 440.190429688 283.181640625 490.0390625 248.181640625 510.190429688 196.211914062 c 1
+ 491.099609375 178.181640625 l 1
+277.91796875 412.576171875 m 0
+ 253.5234375 412.576171875 233.372070312 432.727539062 233.372070312 456.060546875 c 0
+ 233.372070312 480.454101562 253.5234375 500.606445312 277.91796875 500.606445312 c 0
+ 301.250976562 500.606445312 322.462890625 479.393554688 322.462890625 456.060546875 c 0
+ 322.462890625 432.727539062 300.190429688 412.576171875 277.91796875 412.576171875 c 0
+491.099609375 412.576171875 m 0
+ 466.706054688 412.576171875 447.615234375 432.727539062 447.615234375 456.060546875 c 0
+ 447.615234375 480.454101562 466.706054688 500.606445312 491.099609375 500.606445312 c 0
+ 516.553710938 500.606445312 535.645507812 480.454101562 535.645507812 456.060546875 c 0
+ 535.645507812 431.666992188 515.493164062 412.576171875 491.099609375 412.576171875 c 0
+EndSplineSet
+EndChar
+
+StartChar: uni262D
+Encoding: 9773 9773 6517
+Width: 795
+VWidth: 0
+Flags: HW
+LayerCount: 2
+Fore
+SplineSet
+760.046875 44.19921875 m 1
+ 760.046875 25.255859375 743.209960938 0 713.744140625 -2.1044921875 c 0
+ 705.325195312 -2.1044921875 697.958007812 2.1044921875 689.5390625 9.470703125 c 2
+ 584.305664062 113.654296875 l 1
+ 541.157226562 86.29296875 490.64453125 72.6123046875 433.818359375 72.6123046875 c 0
+ 335.94921875 72.6123046875 260.1796875 119.96875 227.556640625 187.319335938 c 1
+ 207.561523438 168.376953125 l 1
+ 224.400390625 154.696289062 232.818359375 144.172851562 232.818359375 136.805664062 c 0
+ 232.818359375 125.229492188 227.556640625 118.916015625 215.981445312 118.916015625 c 0
+ 205.458007812 118.916015625 195.986328125 127.334960938 185.461914062 143.120117188 c 1
+ 138.106445312 68.4033203125 102.326171875 30.5185546875 76.0185546875 30.5185546875 c 0
+ 50.7607421875 30.5185546875 34.9765625 50.5126953125 34.9765625 75.76953125 c 0
+ 34.9765625 118.916015625 142.31640625 181.004882812 145.473632812 183.110351562 c 1
+ 128.634765625 195.737304688 120.216796875 206.260742188 120.216796875 214.680664062 c 0
+ 120.216796875 224.15234375 130.740234375 231.518554688 139.159179688 231.518554688 c 0
+ 148.629882812 231.518554688 158.100585938 223.099609375 169.676757812 206.260742188 c 1
+ 219.137695312 253.618164062 l 1
+ 253.866210938 253.618164062 l 1
+ 289.645507812 194.686523438 342.263671875 165.21875 408.560546875 165.21875 c 0
+ 436.973632812 165.21875 468.544921875 174.69140625 505.377929688 192.581054688 c 1
+ 266.4921875 432.518554688 l 1
+ 192.828125 360.958984375 l 1
+ 100.220703125 453.56640625 l 1
+ 254.916992188 607.208984375 l 1
+ 413.822265625 580.900390625 l 1
+ 325.424804688 491.451171875 l 1
+ 570.622070312 246.251953125 l 1
+ 603.245117188 275.717773438 619.030273438 319.916992188 619.030273438 377.795898438 c 0
+ 619.030273438 503.026367188 515.900390625 634.571289062 418.030273438 690.346679688 c 1
+ 422.240234375 699.817382812 l 1
+ 586.407226562 667.194335938 715.84765625 544.069335938 715.84765625 363.063476562 c 0
+ 715.84765625 278.875 692.6953125 215.734375 646.391601562 172.586914062 c 1
+ 750.575195312 67.3515625 l 2
+ 756.888671875 62.08984375 760.045898438 54.7236328125 760.045898438 44.2001953125 c 1
+ 760.046875 44.19921875 l 1
+EndSplineSet
+EndChar
+
+StartChar: smileface
+Encoding: 9786 9786 6518
+Width: 770
+VWidth: 0
+Flags: HWO
+LayerCount: 2
+Fore
+SplineSet
+735.0390625 350 m 0
+ 735.0390625 151.224609375 571.28515625 0 385.0390625 0 c 0
+ 196.283203125 0 35.0390625 151.901367188 35.0390625 350 c 0
+ 35.0390625 535.947265625 186.024414062 700 385.0390625 700 c 0
+ 571.11328125 700 735.0390625 548.10546875 735.0390625 350 c 0
+691.553710938 350 m 0
+ 691.553710938 524.41796875 548.083984375 657.576171875 385.0390625 657.576171875 c 0
+ 210.642578125 657.576171875 77.462890625 514.188476562 77.462890625 350 c 0
+ 77.462890625 185.216796875 211.353515625 42.423828125 385.0390625 42.423828125 c 0
+ 548.78125 42.423828125 691.553710938 174.909179688 691.553710938 350 c 0
+500.646484375 256.666992188 m 1
+ 519.736328125 238.63671875 l 1
+ 494.28125 186.666992188 442.311523438 153.788085938 385.040039062 153.788085938 c 0
+ 327.767578125 153.788085938 274.736328125 186.666992188 250.342773438 238.63671875 c 1
+ 268.373046875 256.666992188 l 1
+ 302.3125 231.211914062 342.616210938 217.423828125 385.040039062 217.423828125 c 0
+ 426.403320312 217.423828125 467.767578125 231.211914062 500.646484375 256.666992188 c 1
+535.646484375 456.060546875 m 0
+ 535.646484375 431.666992188 515.494140625 412.576171875 491.100585938 412.576171875 c 0
+ 466.706054688 412.576171875 447.615234375 432.727539062 447.615234375 456.060546875 c 0
+ 447.615234375 480.455078125 466.706054688 500.606445312 491.100585938 500.606445312 c 0
+ 516.5546875 500.606445312 535.646484375 480.455078125 535.646484375 456.060546875 c 0
+322.462890625 456.060546875 m 0
+ 322.462890625 432.727539062 300.190429688 412.576171875 277.91796875 412.576171875 c 0
+ 253.5234375 412.576171875 233.372070312 432.727539062 233.372070312 456.060546875 c 0
+ 233.372070312 480.455078125 253.5234375 500.606445312 277.91796875 500.606445312 c 0
+ 301.250976562 500.606445312 322.462890625 479.393554688 322.462890625 456.060546875 c 0
 EndSplineSet
-Validated: 527361
 EndChar
 EndChars
 EndSplineFont